## sdformat 9.2.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
  CMAKE_POLICY(SET CMP0004 NEW)
endif(COMMAND CMAKE_POLICY)
enable_testing()

# with -fPIC
if(UNIX AND NOT WIN32)
  set (CMAKE_INSTALL_PREFIX "/usr" CACHE STRING "Install Prefix")
 find_program(CMAKE_UNAME uname /bin /usr/bin /usr/local/bin )
 if(CMAKE_UNAME)
   exec_program(uname ARGS -m OUTPUT_VARIABLE CMAKE_SYSTEM_PROCESSOR)
   set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_SYSTEM_PROCESSOR} CACHE INTERNAL
     "processor type (i386 and x86_64)")
   if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
     ADD_DEFINITIONS(-fPIC)
   endif(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
 endif(CMAKE_UNAME)
endif()

project (sdformat9)

# The protocol version has nothing to do with the package version set below.
# It represents the current version of sdformat implement by the software
set (SDF_PROTOCOL_VERSION 1.7)

set (SDF_MAJOR_VERSION 9)
set (SDF_MINOR_VERSION 2)
set (SDF_PATCH_VERSION 0)

set (SDF_VERSION ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION})
set (SDF_VERSION_FULL ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION}.${SDF_PATCH_VERSION})

string (TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
string(REGEX REPLACE "[0-9]+" "" PROJECT_NAME_NO_VERSION ${PROJECT_NAME})
string(TOLOWER ${PROJECT_NAME_NO_VERSION} PROJECT_NAME_NO_VERSION_LOWER)
set(PROJECT_EXPORT_NAME ${PROJECT_NAME_LOWER})
set(PROJECT_LIBRARY_TARGET_NAME ${PROJECT_NAME_LOWER})

set (project_cmake_dir ${PROJECT_SOURCE_DIR}/cmake
  CACHE PATH "Location of CMake scripts")

message (STATUS "${PROJECT_NAME} version ${SDF_VERSION_FULL}")
set (CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

#============================================================================
# We turn off extensions because (1) we do not ever want to use non-standard
# compiler extensions, and (2) this variable is on by default, causing cmake
# to choose the flag -std=gnu++14 instead of -std=c++14 when the C++14
# features are requested. Explicitly turning this flag off will force cmake to
# choose -std=c++14.
# See https://bitbucket.org/ignitionrobotics/ign-cmake/issues/13 for more info.
set(CMAKE_CXX_EXTENSIONS off)

# Include GNUInstallDirs to get canonical paths
include(GNUInstallDirs)

# Default test type for test all over source
set(TEST_TYPE "UNIT")

# developer's option to cache PKG_CONFIG_PATH and
# LD_LIBRARY_PATH for local installs
if(PKG_CONFIG_PATH)
  set (ENV{PKG_CONFIG_PATH} ${PKG_CONFIG_PATH}:$ENV{PKG_CONFIG_PATH})
endif()
if(LD_LIBRARY_PATH)
  set (ENV{LD_LIBRARY_PATH} ${LD_LIBRARY_PATH}:$ENV{LD_LIBRARY_PATH})
endif()

set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/sdformat-${SDF_VERSION}/sdf")
set (LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR} CACHE STRING "Installation directory for libraries (relative to CMAKE_INSTALL_PREFIX)")
set (BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR} CACHE STRING "Installation directory for binaries (relative to CMAKE_INSTALL_PREFIX)")
set (USE_FULL_RPATH OFF CACHE BOOL "Set to true to enable full rpath")

set(PKG_NAME SDFormat)
set(sdf_target sdformat${SDF_MAJOR_VERSION})
set(sdf_config_install_dir "${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME_LOWER}/")
set(sdf_import_target_name ${PROJECT_EXPORT_NAME}::${sdf_target})
set(sdf_target_output_filename "${sdf_target}-targets.cmake")


if (USE_FULL_RPATH)
  # use, i.e. don't skip the full RPATH for the build tree
  set(CMAKE_SKIP_BUILD_RPATH  FALSE)

  # when building, don't use the install RPATH already
  # (but later on when installing)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")

  # add the automatically determined parts of the RPATH
  # which point to directories outside the build tree to the install RPATH
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

  # the RPATH to be used when installing, but only if its not a system directory
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
  endif("${isSystemDir}" STREQUAL "-1")
endif()

set (BUILD_SDF ON CACHE INTERNAL "Build SDF" FORCE)
set (build_errors "" CACHE INTERNAL "build errors" FORCE)
set (build_warnings "" CACHE INTERNAL "build warnings" FORCE)

set (sdf_cmake_dir ${PROJECT_SOURCE_DIR}/cmake CACHE PATH
     "Location of CMake scripts")

include (${sdf_cmake_dir}/SDFUtils.cmake)

message (STATUS "\n\n====== Finding 3rd Party Packages ======")
 # Use of tinyxml. System installation on UNIX. Internal copy on WIN
if (UNIX)
  message (STATUS "Using system tinyxml")
  set (USE_EXTERNAL_TINYXML True)
elseif(WIN32)
  message (STATUS "Using internal tinyxml code")
  set (USE_EXTERNAL_TINYXML False)
else()
  message (STATUS "Unknown platform")
  BUILD_ERROR("Unknown platform")
endif()
include (${sdf_cmake_dir}/SearchForStuff.cmake)
message (STATUS "----------------------------------------\n")

#####################################
# Set the default build type
if (NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug Release RelWithDebInfo Profile Check" FORCE)
endif (NOT CMAKE_BUILD_TYPE)
string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPERCASE)

set (BUILD_TYPE_PROFILE FALSE)
set (BUILD_TYPE_RELEASE FALSE)
set (BUILD_TYPE_RELWITHDEBINFO FALSE)
set (BUILD_TYPE_DEBUG FALSE)

if ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "PROFILE")
  set (BUILD_TYPE_PROFILE TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELEASE")
  set (BUILD_TYPE_RELEASE TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELWITHDEBINFO")
  set (BUILD_TYPE_RELWITHDEBINFO TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "DEBUG")
  set (BUILD_TYPE_DEBUG TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "COVERAGE")
  include (${project_cmake_dir}/CodeCoverage.cmake)
  set (BUILD_TYPE_DEBUG TRUE)
  SETUP_TARGET_FOR_COVERAGE(coverage ctest coverage)
else()
  # NONE is a valid CMAKE_BUILD_TYPE
  if (NOT "${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "NONE")
    build_error("CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} unknown. Valid options are: Debug Release RelWithDebInfo Profile Coverage None")
  endif()
endif()

#####################################
# Handle CFlags
unset (CMAKE_C_FLAGS_ALL CACHE)
unset (CMAKE_CXX_FLAGS CACHE)

# USE_HOST_CFLAGS (default TRUE)
# Will check building host machine for proper cflags
if(NOT DEFINED USE_HOST_CFLAGS OR USE_HOST_CFLAGS)
  message(STATUS "Enable host CFlags")
  include (${project_cmake_dir}/HostCFlags.cmake)
endif()

# USE_UPSTREAM_CFLAGS (default TRUE)
# Will use predefined ignition developers cflags
if(NOT DEFINED USE_UPSTREAM_CFLAGS OR USE_UPSTREAM_CFLAGS)
  message(STATUS "Enable upstream CFlags")
  include(${project_cmake_dir}/DefaultCFlags.cmake)
endif()

# Check if warning options are avaliable for the compiler and return WARNING_CXX_FLAGS variable
if (MSVC)
  set(WARN_LEVEL "/W4")

  # Unable to be filtered flags (failing due to limitations in filter_valid_compiler_warnings)
  # Handling exceptions rightly and ignore unknown pragmas
  set(UNFILTERED_FLAGS "/EHsc /wd4068")
else()
  # Equivalent to Wall (according to man gcc) but removed the unknown pragmas since we use
  # MSVC only pragmas all over the code
  list(APPEND WARN_LEVEL -Waddress -Warray-bounds -Wcomment -Wformat -Wnonnull)
  list(APPEND WARN_LEVEL -Wparentheses -Wreorder -Wreturn-type)
  list(APPEND WARN_LEVEL -Wsequence-point -Wsign-compare -Wstrict-aliasing)
  list(APPEND WARN_LEVEL -Wstrict-overflow=1 -Wswitch -Wtrigraphs -Wuninitialized)
  list(APPEND WARN_LEVEL -Wunused-function -Wunused-label -Wunused-value)
  list(APPEND WARN_LEVEL -Wunused-variable -Wvolatile-register-var)

  # Unable to be filtered flags (failing due to limitations in filter_valid_compiler_warnings)
  set(UNFILTERED_FLAGS "-Wc++17-compat")
endif()

filter_valid_compiler_warnings(${WARN_LEVEL} -Wextra -Wno-long-long
  -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wno-unused-value
  -Wfloat-equal -Wshadow -Winit-self -Wswitch-default
  -Wmissing-include-dirs -pedantic -Wno-pragmas)
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}${WARNING_CXX_FLAGS} ${UNFILTERED_FLAGS}")

#################################################
# OS Specific initialization
if (UNIX)
  sdf_setup_unix()
endif ()

if (WIN32)
  sdf_setup_windows()
endif ()

if (APPLE)
  sdf_setup_apple()
endif ()

#################################################
# Print warnings and errors
if ( build_warnings )
  message(WARNING "-- BUILD WARNINGS")
  foreach (msg ${build_warnings})
    message(WARNING "-- ${msg}")
  endforeach ()
  message(WARNING "-- END BUILD WARNINGS\n")
endif (build_warnings)

########### Add uninstall target ###############
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P
  "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake")

if (build_errors)
  message(SEND_ERROR "-- BUILD ERRORS: These must be resolved before compiling.")
  foreach (msg ${build_errors})
    message(SEND_ERROR "-- ${msg}")
  endforeach ()
  message(SEND_ERROR "-- END BUILD ERRORS\n")
  message (FATAL_ERROR "Errors encountered in build. Please see the BUILD ERRORS above.")

else (build_errors)

  ########################################
  # Write the config.h file
  configure_file (${sdf_cmake_dir}/sdf_config.h.in
    ${PROJECT_BINARY_DIR}/sdf/sdf_config.h)
  sdf_install_includes("" ${PROJECT_BINARY_DIR}/sdf/sdf_config.h)

  message (STATUS "C Flags:${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}}")
  message (STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
  message (STATUS "Install path: ${CMAKE_INSTALL_PREFIX}")

  if (BUILD_SDF)
    include_directories(include
      ${PROJECT_BINARY_DIR}
      ${PROJECT_BINARY_DIR}/include
      )

    link_directories(${PROJECT_BINARY_DIR}/src)

    add_subdirectory(test)
    add_subdirectory(src)
    add_subdirectory(include/sdf)
    add_subdirectory(sdf)
    add_subdirectory(conf)
    add_subdirectory(doc)
  endif(BUILD_SDF)

  ########################################
  # Make the package config file
  configure_file(${CMAKE_SOURCE_DIR}/cmake/sdformat_pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME_LOWER}.pc @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME_LOWER}.pc DESTINATION
    ${LIB_INSTALL_DIR}/pkgconfig COMPONENT pkgconfig)

  ########################################
  # Configure documentation uploader
  configure_file("${CMAKE_SOURCE_DIR}/cmake/upload_doc.sh.in"
    ${CMAKE_BINARY_DIR}/upload_doc.sh @ONLY)

  ########################################
  # Make the cmake config files
  set(sdf_config_input  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/sdf_config.cmake.in")
  set(sdf_config_output "cmake/${sdf_target}-config.cmake")
  set(sdf_version_output "cmake/${sdf_target}-config-version.cmake")
  set(sdf_config_install_dir "${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME_LOWER}/")

  #--------------------------------------
  # Configure and install the config file
  configure_package_config_file(
    ${sdf_config_input}
    ${sdf_config_output}
    INSTALL_DESTINATION ${sdf_config_install_dir}
    NO_CHECK_REQUIRED_COMPONENTS_MACRO)

  #--------------------------------------
  # Configure and install the version file
  write_basic_package_version_file(
      ${CMAKE_CURRENT_BINARY_DIR}/${sdf_version_output}
      VERSION "${SDF_VERSION_FULL}"
      COMPATIBILITY SameMajorVersion)

  install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${sdf_config_output}
    ${CMAKE_CURRENT_BINARY_DIR}/${sdf_version_output}
    DESTINATION ${sdf_config_install_dir}
    COMPONENT cmake)

  ########################################
  # Package Creation:
  include (${sdf_cmake_dir}/sdf_cpack.cmake)
  set (CPACK_PACKAGE_VERSION "${SDF_VERSION_FULL}")
  set (CPACK_PACKAGE_VERSION_MAJOR "${SDF_MAJOR_VERSION}")

=== src/CMakeLists.txt ===
include (${sdf_cmake_dir}/SDFUtils.cmake)

link_directories(
  ${PROJECT_BINARY_DIR}/test
)

if (NOT USE_INTERNAL_URDF)
  link_directories(${URDF_LIBRARY_DIRS})
endif()

if (USE_EXTERNAL_TINYXML)
  link_directories(${tinyxml_LIBRARY_DIRS})
endif()

set (sources
  Actor.cc
  AirPressure.cc
  Altimeter.cc
  Atmosphere.cc
  Box.cc
  Camera.cc
  Collision.cc
  Console.cc
  Converter.cc
  Cylinder.cc
  Element.cc
  Error.cc
  Exception.cc
  Frame.cc
  FrameSemantics.cc
  Filesystem.cc
  Geometry.cc
  Gui.cc
  ign.cc
  Imu.cc
  Joint.cc
  JointAxis.cc
  Lidar.cc
  Light.cc
  Link.cc
  Magnetometer.cc
  Material.cc
  Mesh.cc
  Model.cc
  Noise.cc
  parser.cc
  parser_urdf.cc
  Param.cc
  Pbr.cc
  Physics.cc
  Plane.cc
  Root.cc
  Scene.cc
  SDF.cc
  SDFExtension.cc
  SemanticPose.cc
  Sensor.cc
  Sphere.cc
  Surface.cc
  Types.cc
  Utils.cc
  Visual.cc
  World.cc
)

if (USE_EXTERNAL_TINYXML)
  include_directories(${tinyxml_INCLUDE_DIRS})
else()
  set(sources ${sources}
    win/tinyxml/tinystr.cpp
    win/tinyxml/tinyxmlerror.cpp
    win/tinyxml/tinyxml.cpp
    win/tinyxml/tinyxmlparser.cpp)

    install (FILES win/tinyxml/tinyxml.h
	    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/sdformat-${SDF_VERSION})
endif()

if (USE_INTERNAL_URDF)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/urdf)
  set(sources ${sources}
  urdf/urdf_parser/model.cpp
  urdf/urdf_parser/link.cpp
  urdf/urdf_parser/joint.cpp
  urdf/urdf_parser/pose.cpp
  urdf/urdf_parser/twist.cpp
  urdf/urdf_parser/urdf_model_state.cpp
  urdf/urdf_parser/urdf_sensor.cpp
  urdf/urdf_parser/world.cpp)
else()
  include_directories(${URDF_INCLUDE_DIRS})
endif()

set (gtest_sources
  Actor_TEST.cc
  AirPressure_TEST.cc
  Altimeter_TEST.cc
  Atmosphere_TEST.cc
  Box_TEST.cc
  Camera_TEST.cc
  Collision_TEST.cc
  Console_TEST.cc
  Cylinder_TEST.cc
  Element_TEST.cc
  Error_TEST.cc
  Exception_TEST.cc
  Frame_TEST.cc
  Filesystem_TEST.cc
  Geometry_TEST.cc
  Gui_TEST.cc
  Imu_TEST.cc
  Joint_TEST.cc
  JointAxis_TEST.cc
  Lidar_TEST.cc
  Light_TEST.cc
  Link_TEST.cc
  Magnetometer_TEST.cc
  Material_TEST.cc
  Mesh_TEST.cc
  Model_TEST.cc
  Noise_TEST.cc
  parser_urdf_TEST.cc
  Param_TEST.cc
  parser_TEST.cc
  Pbr_TEST.cc
  Physics_TEST.cc
  Plane_TEST.cc
  Root_TEST.cc
  Scene_TEST.cc
  SemanticPose_TEST.cc
  SDF_TEST.cc
  Sensor_TEST.cc
  Sphere_TEST.cc
  Surface_TEST.cc
  Types_TEST.cc
  Visual_TEST.cc
  World_TEST.cc
)

# Build this test file only if Ignition Tools is installed.
if (IGNITION-TOOLS_BINARY_DIRS)
  set (gtest_sources ${gtest_sources}
    ign_TEST.cc
  )
endif()

sdf_build_tests(${gtest_sources})

if (NOT WIN32)
  set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS Utils.cc)
  sdf_build_tests(Utils_TEST.cc)
endif()

if (NOT WIN32)
  set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS FrameSemantics.cc)
  sdf_build_tests(FrameSemantics_TEST.cc)
endif()

if (NOT WIN32)
  set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS Converter.cc)
  sdf_build_tests(Converter_TEST.cc)
endif()

sdf_add_library(${sdf_target} ${sources})
target_link_libraries(${sdf_target} PUBLIC ${IGNITION-MATH_LIBRARIES})

target_include_directories(${sdf_target}
  PUBLIC
    ${IGNITION-MATH_INCLUDE_DIRS}
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}/..>
)

if (USE_EXTERNAL_TINYXML)
  target_link_libraries(${sdf_target} PRIVATE ${tinyxml_LIBRARIES})
else()
  # Ignore the warnings from the internal library
  set_target_properties(sdformat${SDF_MAJOR_VERSION} PROPERTIES
      LINK_FLAGS "/IGNORE:4049 /IGNORE:4217")
endif()

message (STATUS "URDF_LIBRARY_DIRS=${URDF_LIBRARY_DIRS}")
message (STATUS "URDF_LIBRARIES=${URDF_LIBRARIES}")

if (NOT USE_INTERNAL_URDF)
  target_link_libraries(${sdf_target} PRIVATE ${URDF_LIBRARIES})
endif()

sdf_install_library(${sdf_target})

if(NOT WIN32)
  add_subdirectory(cmd)
endif()

=== debian/changelog ===
sdformat (9.2.0+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Fix autopkgtest

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 18 Apr 2020 19:13:23 +0200

sdformat (9.2.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 18 Apr 2020 11:30:47 +0200

sdformat (9.2.0+dfsg-2) experimental; urgency=medium

  * Team upload.
  * Update d/watch to Github (switch suffix to ds)
  * add Salsa CI

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 18 Apr 2020 11:26:12 +0200

sdformat (9.2.0+dfsg-1) experimental; urgency=medium

  * Team upload.

  [ Jose Luis Rivero ]
  * Update watch file

  [ Jochen Sprickerhof ]
  * Support all versions in d/watch
  * New upstream version 9.2.0+dfsg
  * Update copyright
  * Rebase patches
  * Rename packages (unversion -dev, new API)
  * Update d/control

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 13 Apr 2020 09:54:10 +0200

## sdformat 9.3.0%2Bds

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

.PHONY: override_dh_auto_configure     \
        override_dh_auto_build-indep   \
	override_dh_auto_test-indep    \
        override_dh_auto_test

override_dh_auto_configure:
	dh_auto_configure -- \
            -DUSE_HOST_CFLAGS:BOOL=False \
            -DUSE_UPSTREAM_CFLAGS:BOOL=False

override_dh_auto_build-indep:
	dh_auto_build -- doc # Generate documentation.

override_dh_auto_test-arch:
	HOME=$(CURDIR) LC_ALL=POSIX dh_auto_test

# No test can be done without the binaries
override_dh_auto_test-indep:

%:
	dh $@ --build-system=cmake

## sdformat 9.3.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 set (SDF_PROTOCOL_VERSION 1.7)
 
 set (SDF_MAJOR_VERSION 9)
-set (SDF_MINOR_VERSION 2)
+set (SDF_MINOR_VERSION 3)
 set (SDF_PATCH_VERSION 0)
 
 set (SDF_VERSION ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION})
@@ -51,7 +51,7 @@
 # to choose the flag -std=gnu++14 instead of -std=c++14 when the C++14
 # features are requested. Explicitly turning this flag off will force cmake to
 # choose -std=c++14.
-# See https://bitbucket.org/ignitionrobotics/ign-cmake/issues/13 for more info.
+# See https://github.com/ignitionrobotics/ign-cmake/issues/13 for more info.
 set(CMAKE_CXX_EXTENSIONS off)
 
 # Include GNUInstallDirs to get canonical paths
@@ -265,7 +265,15 @@
 
     link_directories(${PROJECT_BINARY_DIR}/src)
 
-    add_subdirectory(test)
+    if (NOT DEFINED BUILD_TESTING OR BUILD_TESTING)
+      set(BUILD_SDF_TEST TRUE)
+    else()
+      set(BUILD_SDF_TEST FALSE)
+    endif()
+
+    if (BUILD_SDF_TEST)
+      add_subdirectory(test)
+    endif()
     add_subdirectory(src)
     add_subdirectory(include/sdf)
     add_subdirectory(sdf)
@@ -314,7 +322,3 @@
     COMPONENT cmake)
 
   ########################################
-  # Package Creation:
-  include (${sdf_cmake_dir}/sdf_cpack.cmake)
-  set (CPACK_PACKAGE_VERSION "${SDF_VERSION_FULL}")
-  set (CPACK_PACKAGE_VERSION_MAJOR "${SDF_MAJOR_VERSION}")

=== sdf/CMakeLists.txt ===
add_subdirectory(1.0)
add_subdirectory(1.2)
add_subdirectory(1.3)
add_subdirectory(1.4)
add_subdirectory(1.5)
add_subdirectory(1.6)
add_subdirectory(1.7)

add_custom_target(schema)
add_dependencies(schema schema1_7)

# Generate the EmbeddedSdf.hh file, which contains all the supported SDF
# descriptions in a map of strings. The parser.cc file uses EmbeddedSdf.hh.
execute_process(
  COMMAND ${RUBY} ${CMAKE_SOURCE_DIR}/sdf/embedSdf.rb
  WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/sdf"
  OUTPUT_FILE "${PROJECT_BINARY_DIR}/include/sdf/EmbeddedSdf.hh"
)

# Generate aggregated SDF description files for use by the sdformat.org 
# website. If the description files change, the generated full*.sdf files need 
# to be removed before running this target.
if (IGNITION-TOOLS_BINARY_DIRS)

  # Update this list as new sdformat spec versions are added.
  set(sdf_desc_versions 1.4 1.5 1.6 1.7)

  set(description_targets)
  foreach(desc_ver ${sdf_desc_versions})
    string(REPLACE "." "-" desc_ver_dash ${desc_ver})
    list(APPEND description_targets ${CMAKE_CURRENT_BINARY_DIR}/full_${desc_ver_dash}.sdf)
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/full_${desc_ver_dash}.sdf
      COMMAND
        ${CMAKE_COMMAND} -E env IGN_CONFIG_PATH=${CMAKE_BINARY_DIR}/test/conf
        ${IGNITION-TOOLS_BINARY_DIRS}/ign
      ARGS sdf -d ${desc_ver} > ${CMAKE_CURRENT_BINARY_DIR}/full_${desc_ver_dash}.sdf
      COMMENT "Generating full description for spec ${desc_ver}"
      VERBATIM)
  endforeach()
  add_custom_target(sdf_descriptions DEPENDS ${description_targets} ${sdf_target})
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -91,77 +91,80 @@
   include_directories(${URDF_INCLUDE_DIRS})
 endif()
 
-set (gtest_sources
-  Actor_TEST.cc
-  AirPressure_TEST.cc
-  Altimeter_TEST.cc
-  Atmosphere_TEST.cc
-  Box_TEST.cc
-  Camera_TEST.cc
-  Collision_TEST.cc
-  Console_TEST.cc
-  Cylinder_TEST.cc
-  Element_TEST.cc
-  Error_TEST.cc
-  Exception_TEST.cc
-  Frame_TEST.cc
-  Filesystem_TEST.cc
-  Geometry_TEST.cc
-  Gui_TEST.cc
-  Imu_TEST.cc
-  Joint_TEST.cc
-  JointAxis_TEST.cc
-  Lidar_TEST.cc
-  Light_TEST.cc
-  Link_TEST.cc
-  Magnetometer_TEST.cc
-  Material_TEST.cc
-  Mesh_TEST.cc
-  Model_TEST.cc
-  Noise_TEST.cc
-  parser_urdf_TEST.cc
-  Param_TEST.cc
-  parser_TEST.cc
-  Pbr_TEST.cc
-  Physics_TEST.cc
-  Plane_TEST.cc
-  Root_TEST.cc
-  Scene_TEST.cc
-  SemanticPose_TEST.cc
-  SDF_TEST.cc
-  Sensor_TEST.cc
-  Sphere_TEST.cc
-  Surface_TEST.cc
-  Types_TEST.cc
-  Visual_TEST.cc
-  World_TEST.cc
-)
-
-# Build this test file only if Ignition Tools is installed.
-if (IGNITION-TOOLS_BINARY_DIRS)
-  set (gtest_sources ${gtest_sources}
-    ign_TEST.cc
+if (BUILD_SDF_TEST)
+  set (gtest_sources
+    Actor_TEST.cc
+    AirPressure_TEST.cc
+    Altimeter_TEST.cc
+    Atmosphere_TEST.cc
+    Box_TEST.cc
+    Camera_TEST.cc
+    Collision_TEST.cc
+    Console_TEST.cc
+    Cylinder_TEST.cc
+    Element_TEST.cc
+    Error_TEST.cc
+    Exception_TEST.cc
+    Frame_TEST.cc
+    Filesystem_TEST.cc
+    Geometry_TEST.cc
+    Gui_TEST.cc
+    Imu_TEST.cc
+    Joint_TEST.cc
+    JointAxis_TEST.cc
+    Lidar_TEST.cc
+    Light_TEST.cc
+    Link_TEST.cc
+    Magnetometer_TEST.cc
+    Material_TEST.cc
+    Mesh_TEST.cc
+    Model_TEST.cc
+    Noise_TEST.cc
+    parser_urdf_TEST.cc
+    Param_TEST.cc
+    parser_TEST.cc
+    Pbr_TEST.cc
+    Physics_TEST.cc
+    Plane_TEST.cc
+    Root_TEST.cc
+    Scene_TEST.cc
+    SemanticPose_TEST.cc
+    SDF_TEST.cc
+    Sensor_TEST.cc
+    Sphere_TEST.cc
+    Surface_TEST.cc
+    Types_TEST.cc
+    Visual_TEST.cc
+    World_TEST.cc
   )
-endif()
-
-sdf_build_tests(${gtest_sources})
-
-if (NOT WIN32)
-  set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS Utils.cc)
-  sdf_build_tests(Utils_TEST.cc)
-endif()
-
-if (NOT WIN32)
-  set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS FrameSemantics.cc)
-  sdf_build_tests(FrameSemantics_TEST.cc)
-endif()
-
-if (NOT WIN32)
-  set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS Converter.cc)
-  sdf_build_tests(Converter_TEST.cc)
+  
+  # Build this test file only if Ignition Tools is installed.
+  if (IGNITION-TOOLS_BINARY_DIRS)
+    set (gtest_sources ${gtest_sources}
+      ign_TEST.cc
+    )
+  endif()
+  
+  sdf_build_tests(${gtest_sources})
+  
+  if (NOT WIN32)
+    set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS Utils.cc)
+    sdf_build_tests(Utils_TEST.cc)
+  endif()
+  
+  if (NOT WIN32)
+    set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS FrameSemantics.cc)
+    sdf_build_tests(FrameSemantics_TEST.cc)
+  endif()
+  
+  if (NOT WIN32)
+    set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS Converter.cc)
+    sdf_build_tests(Converter_TEST.cc)
+  endif()
 endif()
 
 sdf_add_library(${sdf_target} ${sources})
+target_compile_features(${sdf_target} PUBLIC cxx_std_17)
 target_link_libraries(${sdf_target} PUBLIC ${IGNITION-MATH_LIBRARIES})
 
 target_include_directories(${sdf_target}
@@ -183,6 +186,10 @@
 message (STATUS "URDF_LIBRARIES=${URDF_LIBRARIES}")
 
 if (NOT USE_INTERNAL_URDF)
+  target_compile_options(${sdf_target} PRIVATE ${URDF_CFLAGS})
+  if (${CMAKE_VERSION} VERSION_GREATER 3.13)
+    target_link_options(${sdf_target} PRIVATE ${URDF_LDFLAGS})
+  endif()
   target_link_libraries(${sdf_target} PRIVATE ${URDF_LIBRARIES})
 endif()

=== include/sdf/CMakeLists.txt ===
include (${sdf_cmake_dir}/SDFUtils.cmake)

set (headers
  Actor.hh
  AirPressure.hh
  Altimeter.hh
  Assert.hh
  Atmosphere.hh
  Box.hh
  Camera.hh
  Collision.hh
  Console.hh
  Cylinder.hh
  Element.hh
  Error.hh
  Exception.hh
  Filesystem.hh
  Frame.hh
  Geometry.hh
  Gui.hh
  Imu.hh
  Joint.hh
  JointAxis.hh
  Lidar.hh
  Light.hh
  Link.hh
  Magnetometer.hh
  Material.hh
  Mesh.hh
  Model.hh
  Noise.hh
  Param.hh
  parser.hh
  Pbr.hh
  Physics.hh
  Plane.hh
  Root.hh
  Scene.hh
  SDFImpl.hh
  SemanticPose.hh
  Sensor.hh
  Sphere.hh
  Surface.hh
  Types.hh
  system_util.hh
  Visual.hh
  World.hh
)

set (sdf_headers "" CACHE INTERNAL "SDF headers" FORCE)
foreach (hdr ${headers})
  APPEND_TO_CACHED_STRING(sdf_headers
    "SDF Headers" "#include <sdf/${hdr}>\n")
endforeach()
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/sdf.hh.in
                ${CMAKE_CURRENT_BINARY_DIR}/sdf.hh)

sdf_install_includes("" ${headers} parser_urdf.hh
  ${CMAKE_CURRENT_BINARY_DIR}/sdf.hh)

=== sdf/1.3/CMakeLists.txt ===
set (sdfs
  1_2.convert
  actor.sdf
  camera.sdf
  collision.sdf
  contact.sdf
  geometry.sdf
  gripper.sdf
  gui.sdf
  imu.sdf
  inertial.sdf
  joint.sdf
  light.sdf
  link.sdf
  model.sdf
  physics.sdf
  plugin.sdf
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  root.sdf
  scene.sdf
  sensor.sdf
  state.sdf
  surface.sdf
  visual.sdf
  world.sdf
)

install(FILES ${sdfs} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${SDF_MAJOR_VERSION}/1.3)

=== sdf/1.5/CMakeLists.txt ===
set (sdfs
  actor.sdf
  altimeter.sdf
  audio_source.sdf
  audio_sink.sdf
  battery.sdf
  box_shape.sdf
  camera.sdf
  collision.sdf
  contact.sdf
  cylinder_shape.sdf
  frame.sdf
  forcetorque.sdf
  geometry.sdf
  gps.sdf
  gripper.sdf
  gui.sdf
  heightmap_shape.sdf
  image_shape.sdf
  imu.sdf
  inertial.sdf
  joint.sdf
  light.sdf
  light_state.sdf
  link.sdf
  link_state.sdf
  logical_camera.sdf
  magnetometer.sdf
  material.sdf
  mesh_shape.sdf
  model.sdf
  model_state.sdf
  noise.sdf
  physics.sdf
  plane_shape.sdf
  plugin.sdf
  polyline_shape.sdf
  population.sdf
  pose.sdf
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  root.sdf
  scene.sdf
  sensor.sdf
  spherical_coordinates.sdf
  sphere_shape.sdf
  sonar.sdf
  state.sdf
  surface.sdf
  transceiver.sdf
  visual.sdf
  world.sdf
)

set (SDF_SCHEMA)

foreach(FIL ${sdfs})
  get_filename_component(ABS_FIL ${FIL} ABSOLUTE)
  get_filename_component(FIL_WE ${FIL} NAME_WE)

  list(APPEND SDF_SCHEMA "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd")

  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd"
    COMMAND ${RUBY} ${CMAKE_SOURCE_DIR}/tools/xmlschema.rb
    ARGS -s ${CMAKE_CURRENT_SOURCE_DIR} -i ${ABS_FIL} -o ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ABS_FIL}
    COMMENT "Running xml schema compiler on ${FIL}"
    VERBATIM)
endforeach()

add_custom_target(schema1_5 ALL DEPENDS ${SDF_SCHEMA})

set_source_files_properties(${SDF_SCHEMA} PROPERTIES GENERATED TRUE)

install(FILES 1_4.convert ${sdfs} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${SDF_MAJOR_VERSION}/1.5)
install(FILES ${SDF_SCHEMA} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${SDF_MAJOR_VERSION}/1.5)

=== sdf/1.7/CMakeLists.txt ===
set (sdfs
  actor.sdf
  altimeter.sdf
  atmosphere.sdf
  audio_source.sdf
  audio_sink.sdf
  battery.sdf
  box_shape.sdf
  camera.sdf
  collision.sdf
  contact.sdf
  cylinder_shape.sdf
  frame.sdf
  forcetorque.sdf
  geometry.sdf
  gps.sdf
  gripper.sdf
  gui.sdf
  heightmap_shape.sdf
  image_shape.sdf
  imu.sdf
  inertial.sdf
  joint.sdf
  light.sdf
  light_state.sdf
  link.sdf
  link_state.sdf
  logical_camera.sdf
  magnetometer.sdf
  material.sdf
  mesh_shape.sdf
  model.sdf
  model_state.sdf
  noise.sdf
  physics.sdf
  plane_shape.sdf
  plugin.sdf
  polyline_shape.sdf
  population.sdf
  pose.sdf
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  root.sdf
  scene.sdf
  sensor.sdf
  spherical_coordinates.sdf
  sphere_shape.sdf
  sonar.sdf
  state.sdf
  surface.sdf
  transceiver.sdf
  visual.sdf
  world.sdf
)

set (SDF_SCHEMA)

foreach(FIL ${sdfs})
  get_filename_component(ABS_FIL ${FIL} ABSOLUTE)
  get_filename_component(FIL_WE ${FIL} NAME_WE)

  list(APPEND SDF_SCHEMA "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd")

  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd"
    COMMAND ${RUBY} ${CMAKE_SOURCE_DIR}/tools/xmlschema.rb
    ARGS -s ${CMAKE_CURRENT_SOURCE_DIR} -i ${ABS_FIL} -o ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ABS_FIL}
    COMMENT "Running xml schema compiler on ${FIL}"
    VERBATIM)
endforeach()

add_custom_target(schema1_7 ALL DEPENDS ${SDF_SCHEMA})

set_source_files_properties(${SDF_SCHEMA} PROPERTIES GENERATED TRUE)

install(FILES 1_6.convert ${sdfs} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${SDF_MAJOR_VERSION}/1.7)
install(FILES ${SDF_SCHEMA} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${SDF_MAJOR_VERSION}/1.7)

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

set(tests
  actor_dom.cc
  audio.cc
  category_bitmask.cc
  cfm_damping_implicit_spring_damper.cc
  collision_dom.cc
  converter.cc
  deprecated_specs.cc
  disable_fixed_joint_reduction.cc
  fixed_joint_reduction.cc
  force_torque_sensor.cc
  frame.cc
  geometry_dom.cc
  include.cc
  includes.cc
  joint_axis_frame.cc
  joint_axis_dom.cc
  joint_dom.cc
  light_dom.cc
  link_dom.cc
  link_light.cc
  locale_fix.cc
  locale_fix_cxx.cc
  material_pbr.cc
  model_dom.cc
  model_versions.cc
  nested_model.cc
  parser_error_detection.cc
  plugin_attribute.cc
  plugin_bool.cc
  plugin_include.cc
  provide_feedback.cc
  root_dom.cc
  sdf_basic.cc
  sdf_custom.cc
  surface_dom.cc
  unknown.cc
  urdf_gazebo_extensions.cc
  urdf_joint_parameters.cc
  visual_dom.cc
  world_dom.cc
)

if (PYTHONINTERP_FOUND AND PY_PSUTIL)
  set(tests ${tests} element_memory_leak.cc)
endif()

find_program(XMLLINT_EXE xmllint)
if (EXISTS ${XMLLINT_EXE})
  set (tests ${tests} schema_test.cc)
else()
  BUILD_WARNING("xmllint not found. schema_test won't be run")
endif()

link_directories(${PROJECT_BINARY_DIR}/test)

sdf_build_tests(${tests})

if (EXISTS ${XMLLINT_EXE})
  # Need to run schema target (build .xsd files) before running schema_test
  add_dependencies(${TEST_TYPE}_schema_test schema)
endif()

# Test symbols having the right name on linux only
if (UNIX AND NOT APPLE)
  configure_file(all_symbols_have_version.bash.in ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash @ONLY)
  add_test(NAME INTEGRATION_versioned_symbols
    COMMAND bash ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash ${CMAKE_BINARY_DIR}/src/libsdformat${SDF_MAJOR_VERSION}.so)
endif()

=== debian/changelog ===
sdformat (9.3.0+ds-3) unstable; urgency=medium

  * Not ready for compat 13:
    CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON kills the arch:all build

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 10 Sep 2020 17:20:56 +0000

sdformat (9.3.0+ds-2) unstable; urgency=medium

  * Ship files for ignition integration

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 09 Sep 2020 09:46:40 +0000

sdformat (9.3.0+ds-1) unstable; urgency=medium

  * New upstream version 9.3.0
  * Update python3 patch
  * Update debhelper to 13
  * Add patch to define PATH_MAX for Debian Hurd
    (Closes: #892231)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 08 Sep 2020 16:19:36 +0000

=== debian/control ===
Source: sdformat
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               python3,
               libtinyxml-dev,
               liburdfdom-dev,
               doxygen,
               graphviz,
               texlive-base,
               texlive-fonts-recommended,
               texlive-latex-extra,
               texlive-latex-recommended,
               texlive-plain-generic,
               ruby,
               libignition-math-dev (>= 6),
               libgtest-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/sdformat
Vcs-Git: https://salsa.debian.org/science-team/sdformat.git
Homepage: http://sdformat.org
Rules-Requires-Root: no

Package: libsdformat9-9
Architecture: any
Multi-Arch: same
Section: libs
Depends: sdformat-sdf (>= ${source:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Simulation Description Format (SDF) parser - Shared library
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package gathers the shared library

Package: libsdformat-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libtinyxml-dev,
         libignition-math-dev (>= 6),
         libsdformat9-9 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libsdformat4-dev, libsdformat6-dev (<< 9.2.0+dfsg-1~)
Replaces: libsdformat4-dev, libsdformat6-dev (<< 9.2.0+dfsg-1~)
Description: Simulation Description Format (SDF) parser - Development files
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package contains development files (headers, shared library
 symbolic link and cmake file).

Package: libsdformat6-dev
Depends: libsdformat-dev, ${misc:Depends}
Architecture: all
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: sdformat-sdf
Architecture: all
Multi-Arch: foreign
Section: libs
Depends: ${misc:Depends}
Description: Simulation Description Format (SDF) parser - SDF files
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package contains SDF (Simulation Description Format) XML files needed by
 the libsdformat.

Package: sdformat-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Description: Simulation Description Format (SDF) parser - Documentation
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package contains the program documentation

=== debian/tests/control ===
Tests: build
Depends: @, pkg-config, build-essential

=== debian/watch ===
version=4
opts=filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
    dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,repacksuffix=+ds \
    https://github.com/osrf/sdformat/tags \
		(?:.*?/)@PACKAGE@.*_(\d[\d.]*)\.tar\.gz

## sdformat 12.3.0%2Bds

=== include/sdf/CMakeLists.txt ===
include (${sdf_cmake_dir}/SDFUtils.cmake)

set (headers
  Actor.hh
  AirPressure.hh
  Altimeter.hh
  Assert.hh
  Atmosphere.hh
  Box.hh
  Camera.hh
  Capsule.hh
  Collision.hh
  Console.hh
  Cylinder.hh
  Element.hh
  Ellipsoid.hh
  Error.hh
  Exception.hh
  Filesystem.hh
  ForceTorque.hh
  Frame.hh
  Geometry.hh
  Gui.hh
  Heightmap.hh
  Imu.hh
  InterfaceElements.hh
  InterfaceFrame.hh
  InterfaceJoint.hh
  InterfaceLink.hh
  InterfaceModel.hh
  InterfaceModelPoseGraph.hh
  Joint.hh
  JointAxis.hh
  Lidar.hh
  Light.hh
  Link.hh
  Magnetometer.hh
  Material.hh
  Mesh.hh
  Model.hh
  NavSat.hh
  Noise.hh
  Param.hh
  parser.hh
  ParserConfig.hh
  ParticleEmitter.hh
  Pbr.hh
  Physics.hh
  Plane.hh
  PrintConfig.hh
  Root.hh
  Scene.hh
  SDFImpl.hh
  SemanticPose.hh
  Sensor.hh
  Sky.hh
  Sphere.hh
  Surface.hh
  Types.hh
  system_util.hh
  Visual.hh
  World.hh
)

set (sdf_headers "" CACHE INTERNAL "SDF headers" FORCE)
foreach (hdr ${headers})
  set(sdf_headers "${sdf_headers}#include <sdf/${hdr}>\n")
endforeach()
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/sdf.hh.in
                ${CMAKE_CURRENT_BINARY_DIR}/sdf.hh)

sdf_install_includes("" ${headers}
  ${CMAKE_CURRENT_BINARY_DIR}/sdf.hh)

=== sdf/1.9/CMakeLists.txt ===
set (sdfs
  actor.sdf
  air_pressure.sdf
  altimeter.sdf
  atmosphere.sdf
  audio_source.sdf
  audio_sink.sdf
  battery.sdf
  box_shape.sdf
  camera.sdf
  capsule_shape.sdf
  collision.sdf
  contact.sdf
  cylinder_shape.sdf
  ellipsoid_shape.sdf
  frame.sdf
  forcetorque.sdf
  geometry.sdf
  gps.sdf
  gripper.sdf
  gui.sdf
  heightmap_shape.sdf
  image_shape.sdf
  imu.sdf
  inertial.sdf
  joint.sdf
  lidar.sdf
  light.sdf
  light_state.sdf
  link.sdf
  link_state.sdf
  logical_camera.sdf
  magnetometer.sdf
  material.sdf
  mesh_shape.sdf
  model.sdf
  model_state.sdf
  noise.sdf
  particle_emitter.sdf
  physics.sdf
  plane_shape.sdf
  plugin.sdf
  polyline_shape.sdf
  population.sdf
  pose.sdf
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  root.sdf
  scene.sdf
  sensor.sdf
  spherical_coordinates.sdf
  sphere_shape.sdf
  sonar.sdf
  state.sdf
  surface.sdf
  transceiver.sdf
  visual.sdf
  world.sdf
)

set (SDF_SCHEMA)

foreach(FIL ${sdfs})
  get_filename_component(ABS_FIL ${FIL} ABSOLUTE)
  get_filename_component(FIL_WE ${FIL} NAME_WE)

  list(APPEND SDF_SCHEMA "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd")

  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd"
    COMMAND ${RUBY} ${CMAKE_SOURCE_DIR}/tools/xmlschema.rb
    ARGS -s ${CMAKE_CURRENT_SOURCE_DIR} -i ${ABS_FIL} -o ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ABS_FIL}
    COMMENT "Running xml schema compiler on ${FIL}"
    VERBATIM)
endforeach()

add_custom_target(schema1_9 ALL DEPENDS ${SDF_SCHEMA})

set_source_files_properties(${SDF_SCHEMA} PROPERTIES GENERATED TRUE)

install(FILES 1_8.convert ${sdfs} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${SDF_MAJOR_VERSION}/1.9)
install(FILES ${SDF_SCHEMA} DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/sdformat${SDF_MAJOR_VERSION}/1.9)
